
////////////////////////////////////////////////////////////////
//Thread-Beispiel, bei dem es nicht um Geschwindigkeitsgewinn geht
//Jede Schlange hat ihren eigenen Thread, damit eine Verzögerung
//bei einem Schlangenobjekt nicht alle anderen ausbremst. Auch der 
//Datum-Uhr-Teil würde durch die Ladezeit die Schlangen stoppen.
//Deshalb bekommt er auch einen eigenen Thread.(Siehe Kommentar)
//In draw beide einmal mit einmal ohne Thread laufen lassen!
///////////////////////////////////////////////////////////////

String message;
int messagex, messagey;
int titelNummer;
int anzahlSchlangen;
ArrayList<Schlange> schlangen; 

///////////////////////////////////////////////////////////////

void setup() {
  //fullScreen();  
  size(1200, 1200);
  smooth();
  frameRate(40);
  textSize(32);
  colorMode(HSB, 360, 255, 255);

  anzahlSchlangen = 20;
  schlangen = new ArrayList<Schlange>(20);

  messagex = 50;
  messagey = height-50;
  message = "";
  titelNummer = 0;
}

///////////////////////////////////////////////////////////////

void draw() { 
  background(0); 

  for (int i=0; i<schlangen.size(); i++) {
    Schlange s = schlangen.get(i);
    s.update();
    s.display();
  }

  // wenn genug Schlangen, dann lösche gelegentlich eine...
  if ((random(0, 1)<0.01) && (schlangen.size() == anzahlSchlangen))
    schlangeLoeschen();

  if (frameCount % 20 == 1) thread("schlangeErzeugen");

  if (frameCount % 300 == 1) thread("webzugriff"); //  webzugriff();
  
  //if (frameCount % 300 == 1) webzugriff(); // alternativ: ohne neuen Thread

  fill(360, 0, 160);
  text(message, messagex, messagey);
}

//////////////////////////////////////////////////////

void schlangeErzeugen() {
  //  delay((int)random(50,2000));
  if (schlangen.size() < anzahlSchlangen)
    schlangen.add(new Schlange((int) random(width-50), (int) random(height-50), 70));
}

void schlangeLoeschen() {
  if (schlangen.size()>0) 
    schlangen.remove((int)random(0, schlangen.size()-1));
}

//////////////////////////////////////////////////////
// Nachrichtenheader als RSS-Feed esen
//////////////////////////////////////////////////////

void webzugriff() {

  String url = "http://www.tagesschau.de/xml/rss2";
  XML rss = loadXML(url);

  // bearbeite die XML-Daten
  XML[] titleXMLElements = rss.getChildren("channel/item/title");
  String[] titles = new String[titleXMLElements.length];
  for (int i = 0; i < titleXMLElements.length; i++) {
    String title = titleXMLElements[i].getContent();
    // speichere alle Titel in einem Array
    titles[i] = title;
  }

  saveXML(rss, "test.txt");
  

  // wähle zufällig einen Titel aus
  if (titleXMLElements.length>0) {
    message = titles[min(titelNummer, titleXMLElements.length-1)];
    messagex = (int)random(50, 200);
    messagey = (int)random(height-200, height-50);
    titelNummer = (titelNummer+1)%5;
  }
}